<?php
class DB_Funciones_Test {
  
    private $conn;
  
    // constructor
    function __construct() {
        require_once 'DB_Connect.php';
        // connecting to database
        $db = new Db_Connect();
        $this->conn = $db->connect();
    }
  
    // destructor
    function __destruct() {
          
    }


    public function findTest($user1) {
        // y que esté 00 en estado
        $stmt = $this->conn->prepare("SELECT * FROM vHTF5Wkj18_tests WHERE (id_user_1 = ? or id_user_2 = ?) and (state = '00' or state = '01' or state = '10');");
  
        $stmt->bind_param("ss", $user1,$user1);
        //$response = array("error" => FALSE);

        if ($stmt->execute()) {
            $test = $stmt->get_result()->fetch_assoc();
            
            
            $rowCount = count($test);
            if ($rowCount > 0) {
                $stmt->close();
                return $test;
            }
            else {
                // Comprobar primero que hay alguno con estado '11'
                $stmt2 = $this->conn->prepare("SELECT * FROM vHTF5Wkj18_tests WHERE (id_user_1 = ? or id_user_2 = ?) and (state = '11')");
      
                $stmt2->bind_param("ss", $user1,$user1);

                if ($stmt2->execute()) {
                    $test2 = $stmt2->get_result()->fetch_assoc();
                    $stmt2->close();
      
                    return $test2;
                }
                else
                    return NULL;
 
            } 
        }
        else {
                return NULL;
        }

    }


    public function crearTest($user1) {
        $stmt = $this->conn->prepare("SELECT id_pairing FROM vHTF5Wkj18_users WHERE id = ?");
  
        $stmt->bind_param("s", $user1);
        $response = array("error" => FALSE);

        if ($stmt->execute()) {
            $user = $stmt->get_result()->fetch_assoc();
            $stmt->close();
  
            $pairing = $user['id_pairing'];

            // Una vez tenemos el id_pairing, buscamos otro usuario con el mismo id_pairing
            $stmt2 = $this->conn->prepare("SELECT id FROM vHTF5Wkj18_users WHERE id_pairing = ? and id != ?");
  
            $stmt2->bind_param("ss", $pairing, $user1);
            $response2 = array("error" => FALSE);

            $other_id = '';

            if ($stmt2->execute()) {
                $user = $stmt2->get_result()->fetch_assoc();
                $stmt2->close();

                $other_id = $user['id'];

            }

            // Ahora insertamos un nuevo registro de test
            $stmt3 = $this->conn->prepare("INSERT INTO vHTF5Wkj18_tests (id_test, id_pairing, id_user_1, id_user_2, index_answers, index_answers_2, puntuation, puntuation_2, solutions, state) VALUES (NULL, ?, ?, ?, NULL, NULL, NULL, NULL, NULL, '00')");
            
            $stmt3->bind_param("sss", $pairing, $user1, $other_id);
            $response3 = array("error" => FALSE);

            if ($stmt3->execute()) 
                return true;
            else 
                return false;
            

            //return $pairing;
        }
    }

    public function insertarResultados($usuario, $puntos, $respuestas_usuario, $estado, $resultados) {
        
        switch ($estado) {

            case '10':  // El primero en responder es el jugador 1
                $stmt3 = $this->conn->prepare("UPDATE vHTF5Wkj18_tests SET 
                puntuation = ?, 
                index_answers = ?,
                state = '10'
                WHERE id_user_1 = ? AND state = '00'");

                $stmt3->bind_param("sss", $puntos, $respuestas_usuario, $usuario);

                if ($stmt3->execute()) {
                    // Se insertó en la bbdd correctamente
                    return "uno correcto";
                } 
                else {
                    // No se insertó en la base de datos correctamente
                    return "uno incorrecto";
                }
                break;


            case '01':  // El primero en responder es el jugador 2
                $stmt3 = $this->conn->prepare("UPDATE vHTF5Wkj18_tests SET 
                puntuation_2 = ?, 
                index_answers_2 = ?,
                state = '01'
                WHERE id_user_2 = ? AND state = '00'");

                $stmt3->bind_param("sss", $puntos, $respuestas_usuario, $usuario);


                if ($stmt3->execute()) {
                    // Se insertó en la bbdd correctamente
                    return "dos correcto";
                } 
                else {
                    // No se insertó en la base de datos
                    return "dos incorrecto";
                }
            break;


            case '112':  // El primero en responder es el jugador 2
                $stmt3 = $this->conn->prepare("UPDATE vHTF5Wkj18_tests SET 
                puntuation_2 = ?, 
                index_answers_2 = ?,
                state = '11',
                solutions = ?
                WHERE id_user_2 = ? AND state = '10'");

                $stmt3->bind_param("ssss", $puntos, $respuestas_usuario, $resultados, $usuario);


                if ($stmt3->execute()) {
                    // Se insertó en la bbdd correctamente
                    return "dos correcto final";
                } 
                else {
                    // No se insertó en la base de datos
                    return "dos incorrecto final";
                }
            break;


            case '111':  // El primero en responder es el jugador 2
                $stmt3 = $this->conn->prepare("UPDATE vHTF5Wkj18_tests SET 
                puntuation = ?, 
                index_answers = ?,
                state = '11',
                solutions = ?
                WHERE id_user_1 = ? AND state = '01'");

                $stmt3->bind_param("ssss", $puntos, $respuestas_usuario, $resultados, $usuario);


                if ($stmt3->execute()) {
                    // Se insertó en la bbdd correctamente
                    return "uno correcto final";
                } 
                else {
                    // No se insertó en la base de datos
                    return "uno incorrecto final";
                }
            break;
            

            default:
                # code...
                break;
        }
        

    }



    public function insertarPuntos($num, $usuario, $puntos, $respuestas) {
        if ($num == 1) {
            $stmt3 = $this->conn->prepare("UPDATE vHTF5Wkj18_tests SET 
            puntuation = ?, 
            index_answers = ?
            WHERE id_user_1 = ? AND (state = '01' OR state = '00')");

            $stmt3->bind_param("sss", $puntos, $respuestas, $usuario);

            $response = array("error" => FALSE);

            if ($stmt3->execute()) {
                // Se insertó en la bbdd correctamente
                return "uno";
            } 
            else {
                // No se insertó en la base de datos correctamente
                return "uno incorrecto";
            }

        }
        else {
            $stmt3 = $this->conn->prepare("UPDATE vHTF5Wkj18_tests SET 
            puntuation_2 = ?, 
            index_answers_2 = ?
            WHERE id_user_2 = ? AND (state = '10' OR state = '00')");

            $stmt3->bind_param("sss", $puntos, $respuestas, $usuario);

            $response = array("error" => FALSE);

            if ($stmt3->execute()) {
                // Se insertó en la bbdd correctamente
                return "dos";
            } 
            else {
                // No se insertó en la base de datos
                return "dos incorrecto";
            }

        }
    }


}
?>